# coding: utf-8

"""
    Platform API

    _OpenAPI specification for the **Platform API** of **Empire**, the allocation and nomination platform of BritNed_  ---  Additional documentation available in the API's [GitHub repository](https://github.com/britned/empire-platform-api) 

    The version of the OpenAPI document: 3.0.9
    Contact: britned.info@britned.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from empire_platform_api_public_client.models.day_ahead_or_intra_day_auction_bid_group_bids import DayAheadOrIntraDayAuctionBidGroupBids

class DayAheadOrIntraDayAuctionBidGroup(BaseModel):
    """
    DayAheadOrIntraDayAuctionBidGroup
    """
    id: StrictStr = Field(..., description="Unique identifier for the record in UUID4 format")
    external_id: Optional[StrictStr] = Field(None, alias="externalId", description="Optional external identifier for the bid, for example to differentiate between traders ")
    bids: conlist(DayAheadOrIntraDayAuctionBidGroupBids) = Field(...)
    __properties = ["id", "externalId", "bids"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DayAheadOrIntraDayAuctionBidGroup:
        """Create an instance of DayAheadOrIntraDayAuctionBidGroup from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in bids (list)
        _items = []
        if self.bids:
            for _item in self.bids:
                if _item:
                    _items.append(_item.to_dict())
            _dict['bids'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DayAheadOrIntraDayAuctionBidGroup:
        """Create an instance of DayAheadOrIntraDayAuctionBidGroup from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DayAheadOrIntraDayAuctionBidGroup.parse_obj(obj)

        _obj = DayAheadOrIntraDayAuctionBidGroup.parse_obj({
            "id": obj.get("id"),
            "external_id": obj.get("externalId"),
            "bids": [DayAheadOrIntraDayAuctionBidGroupBids.from_dict(_item) for _item in obj.get("bids")] if obj.get("bids") is not None else None
        })
        return _obj


